<TeXmacs|1.99.2>

<style|<tuple|beamer|mathemagix|vdh|pari|caas|math-ss>>

<\body>
  <screens|<\shown>
    \;

    <\with|par-mode|center>
      <strong|<\with|font-base-size|15>
        <strong|Faster FFTs in medium precision>
      </with>>

      <strong|Joris van der Hoeven>, Grgoire Lecerf

      <small|CNRS, cole polytechnique>
    </with>

    <\with|par-mode|center>
      <tabular*|<tformat|<cwith|1|1|2|2|cell-valign|c>|<table|<row|<cell|
      >|<cell|>|<cell|>>|<row|<cell|>|<cell|<img|<image|texmacs-chip.ps|0.6w|0.6h||>>>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|<strong|Lyon,
      June 23, 2015<rsub|<math|<rsub|>>>>>|<cell|>>|<row|<cell|>|<cell|<verbatim|http://www.<anim-repeat|<anim-compose|<anim-constant|<with|color|brown|T<space|-0.2spc><with|color|brown|<rsub|<with|math-level|0|font-shape|small-caps|e>>>X<space|-0.2spc>><with|color|dark
      green|<rsub|<with|math-level|0|font-shape|small-caps|m<space|-0.2spc>a<space|-0.4spc>c<space|-0.2spc>s>>>|1sec>|<anim-constant|<with|color|dark
      green|T<space|-0.2spc><with|color|brown|<rsub|<with|math-level|0|font-shape|small-caps|e>>>X<space|-0.2spc>><with|color|brown|<rsub|<with|math-level|0|font-shape|small-caps|m<space|-0.2spc>a<space|-0.4spc>c<space|-0.2spc>s>>>|1sec>>>.org>>|<cell|>>>>>
    </with>

    \;
  </shown>|<\hidden>
    <tit|The challenge: fast multiple precision arithmetic in practice>

    <switch|<\shown>
      <with|gr-mode|<tuple|edit|point>|gr-frame|<tuple|scale|1.0001cm|<tuple|0.0937888gw|0.0491036gh>>|gr-geometry|<tuple|geometry|1par|0.668846par|center>|gr-grid|<tuple|cartesian|<point|0|0>|1>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|10|none>>|gr-edit-grid|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-grid-aspect|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|10|#e0e0ff>>|gr-grid-aspect-props|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|10|#e0e0ff>>|gr-color|red|<graphics||<space|0.2spc>|<point|0|8.1>|<point|1.0|8.2>|<point|1.6|8.4>|<point|2.0|8.5>|<point|2.6|8.7>|<point|3.0|8.9>|<point|3.6|9.6>|<point|4|10>|<point|4.6|10.6>|<point|5|11.3>|<point|5.6|12>|<point|5.6|12>|<point|6|12.5>|<with|text-at-halign|right|<math-at|1|<point|-0.3|1>>>|<with|text-at-halign|right|<math-at|2|<point|-0.3|2>>>|<with|text-at-halign|right|<math-at|3|<point|-0.3|3>>>|<with|text-at-halign|right|<math-at|4|<point|-0.3|4>>>|<with|text-at-halign|right|<math-at|5|<point|-0.3|5>>>|<with|text-at-halign|right|<math-at|6|<point|-0.3|6>>>|<with|text-at-halign|right|<math-at|7|<point|-0.3|7>>>|<with|text-at-halign|right|<math-at|8|<point|-0.3|8>>>|<with|text-at-halign|right|<math-at|9|<point|-0.3|9>>>|<with|text-at-halign|right|<math-at|10|<point|-0.3|10>>>|<with|text-at-halign|right|<math-at|11|<point|-0.3|11>>>|<with|text-at-halign|right|<math-at|12|<point|-0.3|12>>>|<with|text-at-halign|right|<math-at|22|<point|-0.3|22>>>|<with|text-at-halign|right|<math-at|23|<point|-0.3|23>>>|<with|text-at-halign|center|<math-at|7|<point|1|-0.5>>>|<with|text-at-halign|center|<math-at|8|<point|2|-0.5>>>|<with|text-at-halign|center|<math-at|9|<point|3|-0.5>>>|<with|text-at-halign|center|<math-at|10|<point|4|-0.5>>>|<with|text-at-halign|center|<math-at|11|<point|5|-0.5>>>|<with|text-at-halign|center|<math-at|12|<point|6|-0.5>>>|<with|text-at-halign|center|<math-at|13|<point|7|-0.5>>>|<with|text-at-halign|center|<math-at|14|<point|8|-0.5>>>|<with|text-at-halign|center|<math-at|15|<point|9|-0.5>>>|<with|text-at-halign|center|<math-at|16|<point|10|-0.5>>>|<with|text-at-halign|center|<math-at|17|<point|11|-0.5>>>|<with|text-at-halign|center|<math-at|18|<point|12|-0.5>>>|<with|text-at-halign|center|<math-at|19|<point|13|-0.5>>>|<with|text-at-halign|center|<math-at|20|<point|14|-0.5>>>|<text-at|log
      in base 2 of bit precision|<point|9.0|0.5>>|<text-at|log in base 2 of
      overhead|<point|0.25|13.5>>|<with|text-at-halign|center|<math-at|6|<point|0.0|-0.5>>>|<text-at|Overhead
      of MPFR arithmetic|<point|8.0|9.0>>|<point|7.5|9.2>>>
    </shown>|<\hidden>
      <with|gr-mode|<tuple|edit|point>|gr-frame|<tuple|scale|1.0001cm|<tuple|0.0937888gw|0.0491036gh>>|gr-geometry|<tuple|geometry|1par|0.668843par|center>|gr-grid|<tuple|cartesian|<point|0|0>|1>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|10|none>>|gr-edit-grid|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-grid-aspect|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|10|#e0e0ff>>|gr-grid-aspect-props|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|10|#e0e0ff>>|gr-color|red|<graphics||<space|0.2spc>|<point|0|8.1>|<point|1.0|8.2>|<point|1.6|8.4>|<point|2.0|8.5>|<point|2.6|8.7>|<point|3.0|8.9>|<point|3.6|9.6>|<point|4|10>|<point|4.6|10.6>|<point|5|11.3>|<point|5.6|12>|<point|5.6|12>|<point|6|12.5>|<with|color|blue|<point|0|3.7>>|<with|text-at-halign|right|<math-at|1|<point|-0.3|1>>>|<with|text-at-halign|right|<math-at|2|<point|-0.3|2>>>|<with|text-at-halign|right|<math-at|3|<point|-0.3|3>>>|<with|text-at-halign|right|<math-at|4|<point|-0.3|4>>>|<with|text-at-halign|right|<math-at|5|<point|-0.3|5>>>|<with|text-at-halign|right|<math-at|6|<point|-0.3|6>>>|<with|text-at-halign|right|<math-at|7|<point|-0.3|7>>>|<with|text-at-halign|right|<math-at|8|<point|-0.3|8>>>|<with|text-at-halign|right|<math-at|9|<point|-0.3|9>>>|<with|text-at-halign|right|<math-at|10|<point|-0.3|10>>>|<with|text-at-halign|right|<math-at|11|<point|-0.3|11>>>|<with|text-at-halign|right|<math-at|12|<point|-0.3|12>>>|<with|text-at-halign|right|<math-at|22|<point|-0.3|22>>>|<with|text-at-halign|right|<math-at|23|<point|-0.3|23>>>|<with|text-at-halign|center|<math-at|7|<point|1|-0.5>>>|<with|text-at-halign|center|<math-at|8|<point|2|-0.5>>>|<with|text-at-halign|center|<math-at|9|<point|3|-0.5>>>|<with|text-at-halign|center|<math-at|10|<point|4|-0.5>>>|<with|text-at-halign|center|<math-at|11|<point|5|-0.5>>>|<with|text-at-halign|center|<math-at|12|<point|6|-0.5>>>|<with|text-at-halign|center|<math-at|13|<point|7|-0.5>>>|<with|text-at-halign|center|<math-at|14|<point|8|-0.5>>>|<with|text-at-halign|center|<math-at|15|<point|9|-0.5>>>|<with|text-at-halign|center|<math-at|16|<point|10|-0.5>>>|<with|text-at-halign|center|<math-at|17|<point|11|-0.5>>>|<with|text-at-halign|center|<math-at|18|<point|12|-0.5>>>|<with|text-at-halign|center|<math-at|19|<point|13|-0.5>>>|<with|text-at-halign|center|<math-at|20|<point|14|-0.5>>>|<with|color|blue|<point|4.0|9.6>>|<with|color|blue|<point|3.6|9.1>>|<with|color|blue|<point|3.0|7.8>>|<with|color|blue|<point|2.6|7.2>>|<with|color|blue|<point|2.0|6.4>>|<with|color|blue|<point|1.6|6.2>>|<with|color|blue|<point|1.0|5.3>>|<with|color|blue|<point|4.6|10.3>>|<with|color|blue|<point|5.0|11.1>>|<with|color|blue|<point|5.6|11.9>>|<text-at|log
      in base 2 of bit precision|<point|9.0|0.5>>|<text-at|log in base 2 of
      overhead|<point|0.25|13.5>>|<with|text-at-halign|center|<math-at|6|<point|0.0|-0.5>>>|<text-at|Overhead
      of MPFR arithmetic|<point|8.0|9.0>>|<with|color|blue|<text-at|Overhead
      of MPFR mantissa arithmetic|<point|8.0|8.0>>>|<with|color|blue|<point|7.5|8.2>>|<point|7.5|9.2>>>
    </hidden>|<\hidden>
      <with|gr-mode|<tuple|edit|text-at>|gr-frame|<tuple|scale|1.0001cm|<tuple|0.0937888gw|0.0491036gh>>|gr-geometry|<tuple|geometry|1par|0.668843par|center>|gr-grid|<tuple|cartesian|<point|0|0>|1>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|10|none>>|gr-edit-grid|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-grid-aspect|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|10|#e0e0ff>>|gr-grid-aspect-props|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|10|#e0e0ff>>|gr-color|green|<graphics||<space|0.2spc>|<point|0|8.1>|<point|1.0|8.2>|<point|1.6|8.4>|<point|2.0|8.5>|<point|2.6|8.7>|<point|3.0|8.9>|<point|3.6|9.6>|<point|4|10>|<point|4.6|10.6>|<point|5|11.3>|<point|5.6|12>|<point|5.6|12>|<point|6|12.5>|<with|color|blue|<point|0|3.7>>|<with|text-at-halign|right|<math-at|1|<point|-0.3|1>>>|<with|text-at-halign|right|<math-at|2|<point|-0.3|2>>>|<with|text-at-halign|right|<math-at|3|<point|-0.3|3>>>|<with|text-at-halign|right|<math-at|4|<point|-0.3|4>>>|<with|text-at-halign|right|<math-at|5|<point|-0.3|5>>>|<with|text-at-halign|right|<math-at|6|<point|-0.3|6>>>|<with|text-at-halign|right|<math-at|7|<point|-0.3|7>>>|<with|text-at-halign|right|<math-at|8|<point|-0.3|8>>>|<with|text-at-halign|right|<math-at|9|<point|-0.3|9>>>|<with|text-at-halign|right|<math-at|10|<point|-0.3|10>>>|<with|text-at-halign|right|<math-at|11|<point|-0.3|11>>>|<with|text-at-halign|right|<math-at|12|<point|-0.3|12>>>|<with|text-at-halign|right|<math-at|22|<point|-0.3|22>>>|<with|text-at-halign|right|<math-at|23|<point|-0.3|23>>>|<with|text-at-halign|center|<math-at|7|<point|1|-0.5>>>|<with|text-at-halign|center|<math-at|8|<point|2|-0.5>>>|<with|text-at-halign|center|<math-at|9|<point|3|-0.5>>>|<with|text-at-halign|center|<math-at|10|<point|4|-0.5>>>|<with|text-at-halign|center|<math-at|11|<point|5|-0.5>>>|<with|text-at-halign|center|<math-at|12|<point|6|-0.5>>>|<with|text-at-halign|center|<math-at|13|<point|7|-0.5>>>|<with|text-at-halign|center|<math-at|14|<point|8|-0.5>>>|<with|text-at-halign|center|<math-at|15|<point|9|-0.5>>>|<with|text-at-halign|center|<math-at|16|<point|10|-0.5>>>|<with|text-at-halign|center|<math-at|17|<point|11|-0.5>>>|<with|text-at-halign|center|<math-at|18|<point|12|-0.5>>>|<with|text-at-halign|center|<math-at|19|<point|13|-0.5>>>|<with|text-at-halign|center|<math-at|20|<point|14|-0.5>>>|<with|color|blue|<point|4.0|9.6>>|<with|color|blue|<point|3.6|9.1>>|<with|color|blue|<point|3.0|7.8>>|<with|color|blue|<point|2.6|7.2>>|<with|color|blue|<point|2.0|6.4>>|<with|color|blue|<point|1.6|6.2>>|<with|color|blue|<point|1.0|5.3>>|<with|color|blue|<point|4.6|10.3>>|<with|color|blue|<point|5.0|11.1>>|<with|color|blue|<point|5.6|11.9>>|<text-at|log
      in base 2 of bit precision|<point|9.0|0.5>>|<text-at|log in base 2 of
      overhead|<point|0.25|13.5>>|<with|color|red|<point|-0.3|0.0|<point|2.0|1.6>|1.5>>|<with|text-at-halign|center|<math-at|6|<point|0.0|-0.5>>>|<text-at|Overhead
      of MPFR arithmetic|<point|8.0|9.0>>|<with|color|blue|<text-at|Overhead
      of MPFR mantissa arithmetic|<point|8.0|8.0>>>|<with|color|blue|<point|7.5|8.2>>|<point|7.5|9.2>|<with|color|green|<point|0.7|3.2>>|<with|color|green|<point|1.7|5.8>>|<with|color|green|<point|7.5|7.2>>|<with|color|green|<text-at|Overhead
      of QD (double-double/quad-double)|<point|8|7>>>|<with|color|green|<point|-0.3|0>>>>
    </hidden>|<\hidden>
      <with|gr-mode|<tuple|edit|text-at>|gr-frame|<tuple|scale|1.0001cm|<tuple|0.0937888gw|0.0491036gh>>|gr-geometry|<tuple|geometry|1par|0.668843par|center>|gr-grid|<tuple|cartesian|<point|0|0>|1>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|10|none>>|gr-edit-grid|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-grid-aspect|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|10|#e0e0ff>>|gr-grid-aspect-props|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|10|#e0e0ff>>|gr-color|green|<graphics||<space|0.2spc>|<point|0|8.1>|<point|1.0|8.2>|<point|1.6|8.4>|<point|2.0|8.5>|<point|2.6|8.7>|<point|3.0|8.9>|<point|3.6|9.6>|<point|4|10>|<point|4.6|10.6>|<point|5|11.3>|<point|5.6|12>|<point|5.6|12>|<point|6|12.5>|<with|color|blue|<point|0|3.7>>|<with|text-at-halign|right|<math-at|1|<point|-0.3|1>>>|<with|text-at-halign|right|<math-at|2|<point|-0.3|2>>>|<with|text-at-halign|right|<math-at|3|<point|-0.3|3>>>|<with|text-at-halign|right|<math-at|4|<point|-0.3|4>>>|<with|text-at-halign|right|<math-at|5|<point|-0.3|5>>>|<with|text-at-halign|right|<math-at|6|<point|-0.3|6>>>|<with|text-at-halign|right|<math-at|7|<point|-0.3|7>>>|<with|text-at-halign|right|<math-at|8|<point|-0.3|8>>>|<with|text-at-halign|right|<math-at|9|<point|-0.3|9>>>|<with|text-at-halign|right|<math-at|10|<point|-0.3|10>>>|<with|text-at-halign|right|<math-at|11|<point|-0.3|11>>>|<with|text-at-halign|right|<math-at|12|<point|-0.3|12>>>|<with|text-at-halign|right|<math-at|22|<point|-0.3|22>>>|<with|text-at-halign|right|<math-at|23|<point|-0.3|23>>>|<with|text-at-halign|center|<math-at|7|<point|1|-0.5>>>|<with|text-at-halign|center|<math-at|8|<point|2|-0.5>>>|<with|text-at-halign|center|<math-at|9|<point|3|-0.5>>>|<with|text-at-halign|center|<math-at|10|<point|4|-0.5>>>|<with|text-at-halign|center|<math-at|11|<point|5|-0.5>>>|<with|text-at-halign|center|<math-at|12|<point|6|-0.5>>>|<with|text-at-halign|center|<math-at|13|<point|7|-0.5>>>|<with|text-at-halign|center|<math-at|14|<point|8|-0.5>>>|<with|text-at-halign|center|<math-at|15|<point|9|-0.5>>>|<with|text-at-halign|center|<math-at|16|<point|10|-0.5>>>|<with|text-at-halign|center|<math-at|17|<point|11|-0.5>>>|<with|text-at-halign|center|<math-at|18|<point|12|-0.5>>>|<with|text-at-halign|center|<math-at|19|<point|13|-0.5>>>|<with|text-at-halign|center|<math-at|20|<point|14|-0.5>>>|<with|color|blue|<point|4.0|9.6>>|<with|color|blue|<point|3.6|9.1>>|<with|color|blue|<point|3.0|7.8>>|<with|color|blue|<point|2.6|7.2>>|<with|color|blue|<point|2.0|6.4>>|<with|color|blue|<point|1.6|6.2>>|<with|color|blue|<point|1.0|5.3>>|<with|color|blue|<point|4.6|10.3>>|<with|color|blue|<point|5.0|11.1>>|<with|color|blue|<point|5.6|11.9>>|<text-at|log
      in base 2 of bit precision|<point|9.0|0.5>>|<text-at|log in base 2 of
      overhead|<point|0.25|13.5>>|<with|color|red|<point|0.7|1.6>>|<with|color|red|<point|-0.3|0.0|<point|2.0|1.6>|1.5>>|<with|text-at-halign|center|<math-at|6|<point|0.0|-0.5>>>|<text-at|Overhead
      of MPFR arithmetic|<point|8.0|9.0>>|<with|color|blue|<text-at|Overhead
      of MPFR mantissa arithmetic|<point|8.0|8.0>>>|<with|color|blue|<point|7.5|8.2>>|<point|7.5|9.2>|<with|color|red|<point|1.7|3.3>>|<with|color|red|<point|1.3|2.6>>|<with|color|red|<point|2.3|4.4>>|<with|color|red|<point|2.7|5.2>>|<with|color|red|<point|3.3|6.3>>|<with|color|red|<point|3.71690532094315|7.12050663051027>>|<with|color|green|<point|0.7|3.2>>|<with|color|green|<point|1.7|5.8>>|<with|color|red|<point|7.5|6.2>>|<with|color|red|<text-at|Dream
      overhead|<point|8.0|6.0>>>|<with|color|green|<point|7.5|7.2>>|<with|color|green|<text-at|Overhead
      of QD (double-double/quad-double)|<point|8|7>>>>>
    </hidden>|<\hidden>
      <with|gr-mode|<tuple|edit|text-at>|gr-frame|<tuple|scale|1.0001cm|<tuple|0.0937888gw|0.0491036gh>>|gr-geometry|<tuple|geometry|1par|0.668843par|center>|gr-grid|<tuple|cartesian|<point|0|0>|1>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|10|none>>|gr-edit-grid|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-grid-aspect|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|10|#e0e0ff>>|gr-grid-aspect-props|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|10|#e0e0ff>>|<graphics||<space|0.2spc>|<with|color|blue|<point|0.0|5.7>>|<point|6.0|14.5>|<point|5.6|14.0>|<point|5.6|14.0>|<with|color|blue|<point|5.6|13.9>>|<point|5.0|13.3>|<point|4.6|12.6>|<point|4.0|12.0>|<point|3.6|11.6>|<point|3.0|10.9>|<point|1.6|10.4>|<point|2.0|10.5>|<point|1.0|10.2>|<point|0.0|10.1>|<with|text-at-halign|right|<math-at|1|<point|-0.3|1>>>|<with|text-at-halign|right|<math-at|2|<point|-0.3|2>>>|<with|text-at-halign|right|<math-at|3|<point|-0.3|3>>>|<with|text-at-halign|right|<math-at|4|<point|-0.3|4>>>|<with|text-at-halign|right|<math-at|5|<point|-0.3|5>>>|<with|text-at-halign|right|<math-at|6|<point|-0.3|6>>>|<with|text-at-halign|right|<math-at|7|<point|-0.3|7>>>|<with|text-at-halign|right|<math-at|8|<point|-0.3|8>>>|<with|text-at-halign|right|<math-at|9|<point|-0.3|9>>>|<with|text-at-halign|right|<math-at|10|<point|-0.3|10>>>|<with|text-at-halign|right|<math-at|11|<point|-0.3|11>>>|<with|text-at-halign|right|<math-at|12|<point|-0.3|12>>>|<with|text-at-halign|right|<math-at|22|<point|-0.3|22>>>|<with|text-at-halign|right|<math-at|23|<point|-0.3|23>>>|<with|text-at-halign|center|<math-at|7|<point|1|-0.5>>>|<with|text-at-halign|center|<math-at|8|<point|2|-0.5>>>|<with|text-at-halign|center|<math-at|9|<point|3|-0.5>>>|<with|text-at-halign|center|<math-at|10|<point|4|-0.5>>>|<with|text-at-halign|center|<math-at|11|<point|5|-0.5>>>|<with|text-at-halign|center|<math-at|12|<point|6|-0.5>>>|<with|text-at-halign|center|<math-at|13|<point|7|-0.5>>>|<with|text-at-halign|center|<math-at|14|<point|8|-0.5>>>|<with|text-at-halign|center|<math-at|15|<point|9|-0.5>>>|<with|text-at-halign|center|<math-at|16|<point|10|-0.5>>>|<with|text-at-halign|center|<math-at|17|<point|11|-0.5>>>|<with|text-at-halign|center|<math-at|18|<point|12|-0.5>>>|<with|text-at-halign|center|<math-at|19|<point|13|-0.5>>>|<with|text-at-halign|center|<math-at|20|<point|14|-0.5>>>|<with|color|blue|<point|4.6|12.3>>|<with|color|blue|<point|5.0|13.1>>|<with|color|blue|<point|1.6|8.2>>|<with|color|blue|<point|2.0|8.4>>|<with|color|blue|<point|2.6|9.2>>|<with|color|blue|<point|3.0|9.8>>|<with|color|blue|<point|1.0|7.3>>|<with|color|blue|<point|4.0|11.6>>|<with|color|blue|<point|3.6|11.1>>|<point|2.6|10.7>|<text-at|log
      in base 2 of bit precision|<point|9.0|0.5>>|<with|color|red|<point|0.7|1.6>>|<with|color|red|<point|-0.3|0.0|<point|2.0|1.6>|1.5>>|<with|text-at-halign|center|<math-at|6|<point|0.0|-0.5>>>|<text-at|Overhead
      of MPFR arithmetic|<point|8.0|9.0>>|<with|color|blue|<text-at|Overhead
      of MPFR mantissa arithmetic|<point|8.0|8.0>>>|<with|color|blue|<point|7.5|8.2>>|<point|7.5|9.2>|<with|color|red|<point|1.7|3.3>>|<with|color|red|<point|1.3|2.6>>|<with|color|red|<point|2.3|4.4>>|<with|color|red|<point|2.7|5.2>>|<with|color|red|<point|3.3|6.3>>|<with|color|red|<point|3.71690532094315|7.12050663051027>>|<with|color|green|<point|0.7|3.2>>|<with|color|green|<point|1.7|5.8>>|<with|color|red|<point|7.5|6.2>>|<with|color|red|<text-at|Dream
      overhead|<point|8.0|6.0>>>|<with|color|green|<point|7.5|7.2>>|<with|color|green|<text-at|Overhead
      of MPFUN2015 (QD++)?|<point|8|7>>>|<text-at|log in base 2 of
      overhead|<point|-1.8|13.4>>|<text-at|<very-large|AVX-256>|<point|12|12>>>>
    </hidden>>

    <htab|5mm>
  </hidden>|<\hidden>
    <tit|The challenge>

    <\itemize>
      <unroll|<\shown>
        <item><with|color|blue|Long term:> faster general purpose medium
        precision floating point arithmetic.

        <with|color|dark grey|<flat-size|(difficulty: high overhead for
        software implementation of floating point)>>
      </shown>|<\hidden*>
        <item><with|color|blue|This talk:> faster special purpose medium
        precision fixed point arithmetic.

        <with|color|dark grey|<flat-size|(difficulty: higher implementation
        cost)>>
      </hidden*>|<\hidden*>
        <item>Easiest test case: FFT.

        <with|color|dark grey|<flat-size|(sample application: integration of
        p.d.e.s from hydrodynamics)>>
      </hidden*>|<\hidden*>
        <item>General philosophy:

        <\enumerate>
          <item>Optimized implementations of core routines (FFT, BLAS, ...).

          <item>Slower general purpose routines for remaining tasks.
        </enumerate>
      </hidden*>>
    </itemize>

    \;
  </hidden>|<\hidden>
    <tit|Main result (implemented in the Mathemagix system)>

    <anim-repeat|<anim-compose|<anim-constant|<with|gr-mode|<tuple|edit|point>|gr-frame|<tuple|scale|1.0001cm|<tuple|0.0937888gw|0.0491036gh>>|gr-geometry|<tuple|geometry|1par|0.668843par|center>|gr-grid|<tuple|cartesian|<point|0|0>|1>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|10|none>>|gr-edit-grid|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-grid-aspect|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|10|#e0e0ff>>|gr-grid-aspect-props|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|10|#e0e0ff>>|<graphics||<space|0.2spc>|<with|color|blue|<point|0.0|5.7>>|<point|6.0|14.5>|<point|5.6|14.0>|<point|5.6|14.0>|<with|color|blue|<point|5.6|13.9>>|<point|5.0|13.3>|<point|4.6|12.6>|<point|4.0|12.0>|<point|3.6|11.6>|<point|3.0|10.9>|<point|1.6|10.4>|<point|2.0|10.5>|<point|1.0|10.2>|<point|0.0|10.1>|<with|text-at-halign|right|<math-at|1|<point|-0.3|1>>>|<with|text-at-halign|right|<math-at|2|<point|-0.3|2>>>|<with|text-at-halign|right|<math-at|3|<point|-0.3|3>>>|<with|text-at-halign|right|<math-at|4|<point|-0.3|4>>>|<with|text-at-halign|right|<math-at|5|<point|-0.3|5>>>|<with|text-at-halign|right|<math-at|6|<point|-0.3|6>>>|<with|text-at-halign|right|<math-at|7|<point|-0.3|7>>>|<with|text-at-halign|right|<math-at|8|<point|-0.3|8>>>|<with|text-at-halign|right|<math-at|9|<point|-0.3|9>>>|<with|text-at-halign|right|<math-at|10|<point|-0.3|10>>>|<with|text-at-halign|right|<math-at|11|<point|-0.3|11>>>|<with|text-at-halign|right|<math-at|12|<point|-0.3|12>>>|<with|text-at-halign|right|<math-at|22|<point|-0.3|22>>>|<with|text-at-halign|right|<math-at|23|<point|-0.3|23>>>|<with|text-at-halign|center|<math-at|7|<point|1|-0.5>>>|<with|text-at-halign|center|<math-at|8|<point|2|-0.5>>>|<with|text-at-halign|center|<math-at|9|<point|3|-0.5>>>|<with|text-at-halign|center|<math-at|10|<point|4|-0.5>>>|<with|text-at-halign|center|<math-at|11|<point|5|-0.5>>>|<with|text-at-halign|center|<math-at|12|<point|6|-0.5>>>|<with|text-at-halign|center|<math-at|13|<point|7|-0.5>>>|<with|text-at-halign|center|<math-at|14|<point|8|-0.5>>>|<with|text-at-halign|center|<math-at|15|<point|9|-0.5>>>|<with|text-at-halign|center|<math-at|16|<point|10|-0.5>>>|<with|text-at-halign|center|<math-at|17|<point|11|-0.5>>>|<with|text-at-halign|center|<math-at|18|<point|12|-0.5>>>|<with|text-at-halign|center|<math-at|19|<point|13|-0.5>>>|<with|text-at-halign|center|<math-at|20|<point|14|-0.5>>>|<with|color|blue|<point|4.6|12.3>>|<with|color|blue|<point|5.0|13.1>>|<with|color|blue|<point|1.6|8.2>>|<with|color|blue|<point|2.0|8.4>>|<with|color|blue|<point|2.6|9.2>>|<with|color|blue|<point|3.0|9.8>>|<with|color|blue|<point|1.0|7.3>>|<with|color|blue|<point|4.0|11.6>>|<with|color|blue|<point|3.6|11.1>>|<point|2.6|10.7>|<text-at|log
    in base 2 of bit precision|<point|9.0|0.5>>|<with|color|red|<point|0.7|1.6>>|<with|color|red|<point|-0.3|0.0|<point|2.0|1.6>|1.5>>|<with|text-at-halign|center|<math-at|6|<point|0.0|-0.5>>>|<text-at|Overhead
    of MPFR arithmetic|<point|8.0|9.0>>|<with|color|blue|<text-at|Overhead of
    MPFR mantissa arithmetic|<point|8.0|8.0>>>|<with|color|blue|<point|7.5|8.2>>|<point|7.5|9.2>|<with|color|red|<point|1.7|3.3>>|<with|color|red|<point|1.3|2.6>>|<with|color|red|<point|2.3|4.4>>|<with|color|red|<point|2.7|5.2>>|<with|color|red|<point|3.3|6.3>>|<with|color|red|<point|3.71690532094315|7.12050663051027>>|<with|color|green|<point|0.7|3.2>>|<with|color|green|<point|1.7|5.8>>|<with|color|red|<point|7.5|6.2>>|<with|color|red|<text-at|Dream
    overhead|<point|8.0|6.0>>>|<with|color|green|<point|7.5|7.2>>|<with|color|green|<text-at|Overhead
    of double-double/quad-double arithmetic|<point|8|7>>>|<text-at|log in
    base 2 of overhead|<point|-1.8|13.4>>|<text-at|<very-large|AVX-256>|<point|12|12>>>>|0.5sec>|<anim-constant|<with|gr-mode|<tuple|edit|point>|gr-frame|<tuple|scale|1.0001cm|<tuple|0.0937888gw|0.0491036gh>>|gr-geometry|<tuple|geometry|1par|0.668843par|center>|gr-grid|<tuple|cartesian|<point|0|0>|1>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|10|none>>|gr-edit-grid|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-grid-aspect|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|10|#e0e0ff>>|gr-grid-aspect-props|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|10|#e0e0ff>>|gr-color|orange|<graphics||<space|0.2spc>|<with|color|blue|<point|0.0|5.7>>|<point|6.0|14.5>|<point|5.6|14.0>|<point|5.6|14.0>|<with|color|blue|<point|5.6|13.9>>|<point|5.0|13.3>|<point|4.6|12.6>|<point|4.0|12.0>|<point|3.6|11.6>|<point|3.0|10.9>|<point|1.6|10.4>|<point|2.0|10.5>|<point|1.0|10.2>|<point|0.0|10.1>|<with|text-at-halign|right|<math-at|1|<point|-0.3|1>>>|<with|text-at-halign|right|<math-at|2|<point|-0.3|2>>>|<with|text-at-halign|right|<math-at|3|<point|-0.3|3>>>|<with|text-at-halign|right|<math-at|4|<point|-0.3|4>>>|<with|text-at-halign|right|<math-at|5|<point|-0.3|5>>>|<with|text-at-halign|right|<math-at|6|<point|-0.3|6>>>|<with|text-at-halign|right|<math-at|7|<point|-0.3|7>>>|<with|text-at-halign|right|<math-at|8|<point|-0.3|8>>>|<with|text-at-halign|right|<math-at|9|<point|-0.3|9>>>|<with|text-at-halign|right|<math-at|10|<point|-0.3|10>>>|<with|text-at-halign|right|<math-at|11|<point|-0.3|11>>>|<with|text-at-halign|right|<math-at|12|<point|-0.3|12>>>|<with|text-at-halign|right|<math-at|22|<point|-0.3|22>>>|<with|text-at-halign|right|<math-at|23|<point|-0.3|23>>>|<with|text-at-halign|center|<math-at|7|<point|1|-0.5>>>|<with|text-at-halign|center|<math-at|8|<point|2|-0.5>>>|<with|text-at-halign|center|<math-at|9|<point|3|-0.5>>>|<with|text-at-halign|center|<math-at|10|<point|4|-0.5>>>|<with|text-at-halign|center|<math-at|11|<point|5|-0.5>>>|<with|text-at-halign|center|<math-at|12|<point|6|-0.5>>>|<with|text-at-halign|center|<math-at|13|<point|7|-0.5>>>|<with|text-at-halign|center|<math-at|14|<point|8|-0.5>>>|<with|text-at-halign|center|<math-at|15|<point|9|-0.5>>>|<with|text-at-halign|center|<math-at|16|<point|10|-0.5>>>|<with|text-at-halign|center|<math-at|17|<point|11|-0.5>>>|<with|text-at-halign|center|<math-at|18|<point|12|-0.5>>>|<with|text-at-halign|center|<math-at|19|<point|13|-0.5>>>|<with|text-at-halign|center|<math-at|20|<point|14|-0.5>>>|<with|color|blue|<point|4.6|12.3>>|<with|color|blue|<point|5.0|13.1>>|<with|color|blue|<point|1.6|8.2>>|<with|color|blue|<point|2.0|8.4>>|<with|color|blue|<point|2.6|9.2>>|<with|color|blue|<point|3.0|9.8>>|<with|color|blue|<point|1.0|7.3>>|<with|color|blue|<point|4.0|11.6>>|<with|color|blue|<point|3.6|11.1>>|<point|2.6|10.7>|<text-at|log
    in base 2 of bit precision|<point|9.0|0.5>>|<with|color|red|<point|0.7|1.6>>|<with|color|red|<point|-0.3|0.0|<point|2.0|1.6>|1.5>>|<with|text-at-halign|center|<math-at|6|<point|0.0|-0.5>>>|<text-at|Overhead
    of MPFR arithmetic|<point|8.0|9.0>>|<with|color|blue|<text-at|Overhead of
    MPFR mantissa arithmetic|<point|8.0|8.0>>>|<with|color|blue|<point|7.5|8.2>>|<point|7.5|9.2>|<with|color|red|<point|1.7|3.3>>|<with|color|red|<point|1.3|2.6>>|<with|color|red|<point|2.3|4.4>>|<with|color|red|<point|2.7|5.2>>|<with|color|red|<point|3.3|6.3>>|<with|color|red|<point|3.71690532094315|7.12050663051027>>|<with|color|green|<point|0.7|3.2>>|<with|color|green|<point|1.7|5.8>>|<with|color|red|<point|7.5|6.2>>|<with|color|red|<text-at|Dream
    overhead|<point|8.0|6.0>>>|<with|color|green|<point|7.5|7.2>>|<with|color|green|<text-at|Overhead
    of double-double/quad-double arithmetic|<point|8|7>>>|<text-at|log in
    base 2 of overhead|<point|-1.8|13.4>>|<text-at|<very-large|AVX-256>|<point|12|12>>|<with|color|orange|<point|0.6|2.3>>|<with|color|orange|<point|1.2|3.2>>|<with|color|orange|<point|1.5827|4.1>>|<with|color|orange|<text-at|Achieved
    overhead for large FFTs|<point|8|5>>>|<with|color|orange|<point|7.5|5.2>>>>|1sec>>>
  </hidden>|<\hidden>
    <tit|Strategy>

    \;

    <\itemize>
      <unroll|<\shown>
        <item>Redundant \Pcarry-save representation\Q using \Pnail bits\Q.

        <\itemize-minus>
          <item>Classical in hardware.

          <item>Experimental support in GMP library, but disabled by default.
        </itemize-minus>
      </shown>|<\hidden*>
        <item>Use extra nail bits to avoid some normalizations during
        butterflies in the FFT.
      </hidden*>|<\hidden*>
        <item>Suitable replacements for <with|color|blue|TwoSum> and
        <with|color|blue|TwoProduct> algorithms.
      </hidden*>|<\hidden*>
        <item>Careful implementation compatible with SIMD technology,

        with special data type for SIMD multiple precision numbers.
      </hidden*>>
    </itemize>
  </hidden>|<\hidden>
    <tit|Multiple precision representation>

    <\itemize>
      <unroll|<\shown>
        <item><math|\<mu\>=52> (machine precision), <math|E<rsub|min>=-1022>,
        <math|E<rsub|max>=1023> (minimal/maximal exponents).
      </shown>|<\hidden*>
        <item>Redundant fixed point representation
        <math|x=<around*|\<llbracket\>|x<rsub|0>,\<ldots\>,x<rsub|k-1>|\<rrbracket\>>>
        at precision <math|k*p>

        <\eqnarray*>
          <tformat|<table|<row|<cell|x>|<cell|=>|<cell|x<rsub|0>+x<rsub|1>+\<cdots\>+x<rsub|k-1>>>|<row|<cell|<greyed|x>>|<cell|<greyed|=>>|<cell|<greyed|x<rsub|0>+x<rsub|1>*2<rsup|-p>+\<cdots\>+x<rsub|k-1>*2<rsup|-<around*|(|k-1|)>*p>>>>>>
        </eqnarray*>

        where <math|x<rsub|0>,\<ldots\>,x<rsub|k-1>> are integer multiples of
        <math|2<rsup|-p>,\<ldots\>,2<rsup|-k*p>> <greyed|(resp.
        <math|2<rsup|-p>>, ..., <math|2<rsup|-p>>)>.

        <math|x<rsub|0>,\<ldots\>,x<rsub|k-1>> are machine IEEE double
        precision numbers (so that <math|p\<leqslant\>\<mu\>>).

        May release integer multiple condition for least significant number
        <math|x<rsub|k-1>>.
      </hidden*>|<\hidden*>
        <item>We take <math|p=\<mu\>-\<delta\>>, where <math|\<delta\>> is a
        suitable number of <with|color|blue|nail bits>, <abbr|e.g.>
        <math|\<delta\>=4>

        <htab|5mm><with|gr-mode|<tuple|edit|math-at>|gr-frame|<tuple|scale|1cm|<tuple|0.27gw|0.619996gh>>|gr-geometry|<tuple|geometry|0.727451par|0.286908par|center>|gr-transformation|<tuple|<tuple|0.764842187284488|0.0|-0.64421768723769|0.0>|<tuple|0.0|1.0|0.0|0.0>|<tuple|0.64421768723769|0.0|0.764842187284488|0.0>|<tuple|0.0|0.0|0.0|1.0>>|gr-grid|<tuple|empty>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|4|none>>|gr-edit-grid|<tuple|empty>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-grid-aspect|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|4|#e0e0ff>>|gr-grid-aspect-props|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|4|#e0e0ff>>|gr-text-at-halign|center|gr-text-at-valign|center|gr-auto-crop|true|<graphics||<line|<point|-1.0|1.0>|<point|-1.0|0.0>|<point|3.0|0.0>|<point|3.0|1.0>|<point|-1.0|1.0>>|<with|text-at-valign|center|text-at-halign|center|<math-at|x<rsub|0>|<point|-2|0.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|x<rsub|1>|<point|-2|-1>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|\<delta\>|<point|-0.5|0.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|p|<point|1.5|0.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|\<delta\>|<point|2.5|-1>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|p|<point|4.5|-1>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|2<rsup|-2*p>|<point|6.0|1.75>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|2<rsup|-p>|<point|3.0|1.75>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|1|<point|0.0|1.75>>>|<line|<point|2|-0.5>|<point|2.0|-1.5>|<point|6.0|-1.5>|<point|6.0|-1.0>|<point|6.0|-0.5>|<point|2.0|-0.5>>|<with|dash-style|11100|<line|<point|0.0|1.49690765974335>|<point|0.0|-3.5>>>|<with|dash-style|11100|<line|<point|3.0|1.46742293954227>|<point|3.0|-3.5>>>|<with|dash-style|11100|<line|<point|6.0|1.46173435639635>|<point|6.0|-3.5>>>|<with|dash-style|11100|<spline|<point|9|1.5>|<point|9.0|-3.5>>>|<line|<point|5|-2>|<point|5.0|-3.0>|<point|9.0|-3.0>|<point|9.25|-2.75>|<point|9.0|-2.5>|<point|9.25|-2.25>|<point|9.0|-2.0>|<point|5.0|-2.0>>|<with|text-at-valign|center|text-at-halign|center|<math-at|\<delta\>|<point|5.5|-2.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|p|<point|7.5|-2.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|x<rsub|2>|<point|-2|-2.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|2<rsup|-3*p>|<point|9|1.75>>>>><htab|5mm>
      </hidden*>>
    </itemize>
  </hidden>|<\hidden>
    <tit|Normalization >

    \;

    <math|<around*|\<llbracket\>|x<rsub|0>,\<ldots\>,x<rsub|k-1>|\<rrbracket\>>>
    <with|color|blue|normal> if <math|<around*|\||x<rsub|1>|\|>\<less\>2<rsup|-p>,\<ldots\>,<around*|\||x<rsub|k-1>|\|>\<less\>2<rsup|-<around*|(|k-1|)>*p>>

    \;

    <htab|5mm><tiny-switch|<shown|<with|gr-mode|<tuple|edit|math-at>|gr-frame|<tuple|scale|1cm|<tuple|0.27gw|0.619996gh>>|gr-geometry|<tuple|geometry|0.727451par|0.286908par|center>|gr-transformation|<tuple|<tuple|0.764842187284488|0.0|-0.64421768723769|0.0>|<tuple|0.0|1.0|0.0|0.0>|<tuple|0.64421768723769|0.0|0.764842187284488|0.0>|<tuple|0.0|0.0|0.0|1.0>>|gr-grid|<tuple|empty>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|4|none>>|gr-edit-grid|<tuple|empty>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-grid-aspect|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|4|#e0e0ff>>|gr-grid-aspect-props|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|4|#e0e0ff>>|gr-text-at-halign|center|gr-text-at-valign|center|gr-auto-crop|false|<graphics||<line|<point|-1.0|1.0>|<point|-1.0|0.0>|<point|3.0|0.0>|<point|3.0|1.0>|<point|-1.0|1.0>>|<with|text-at-valign|center|text-at-halign|center|<math-at|x<rsub|0>|<point|-2|0.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|x<rsub|1>|<point|-2|-1>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|\<delta\>|<point|-0.5|0.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|p|<point|1.5|0.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|\<delta\>|<point|2.5|-1>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|p|<point|4.5|-1>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|2<rsup|-2*p>|<point|6.0|1.75>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|2<rsup|-p>|<point|3.0|1.75>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|1|<point|0.0|1.75>>>|<line|<point|2|-0.5>|<point|2.0|-1.5>|<point|6.0|-1.5>|<point|6.0|-1.0>|<point|6.0|-0.5>|<point|2.0|-0.5>>|<with|dash-style|11100|<line|<point|0.0|1.49690765974335>|<point|0.0|-3.5>>>|<with|dash-style|11100|<line|<point|3.0|1.46742293954227>|<point|3.0|-3.5>>>|<with|dash-style|11100|<line|<point|6.0|1.46173435639635>|<point|6.0|-3.5>>>|<with|dash-style|11100|<spline|<point|9|1.5>|<point|9.0|-3.5>>>|<line|<point|5|-2>|<point|5.0|-3.0>|<point|9.0|-3.0>|<point|9.25|-2.75>|<point|9.0|-2.5>|<point|9.25|-2.25>|<point|9.0|-2.0>|<point|5.0|-2.0>>|<with|text-at-valign|center|text-at-halign|center|<math-at|\<delta\>|<point|5.5|-2.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|p|<point|7.5|-2.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|x<rsub|2>|<point|-2|-2.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|2<rsup|-3*p>|<point|9|1.75>>>>>>|<hidden|<with|gr-mode|<tuple|edit|math-at>|gr-frame|<tuple|scale|1cm|<tuple|0.27gw|0.619996gh>>|gr-geometry|<tuple|geometry|0.727451par|0.286908par|center>|gr-transformation|<tuple|<tuple|0.764842187284488|0.0|-0.64421768723769|0.0>|<tuple|0.0|1.0|0.0|0.0>|<tuple|0.64421768723769|0.0|0.764842187284488|0.0>|<tuple|0.0|0.0|0.0|1.0>>|gr-grid|<tuple|empty>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|4|none>>|gr-edit-grid|<tuple|empty>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-grid-aspect|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|4|#e0e0ff>>|gr-grid-aspect-props|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|4|#e0e0ff>>|gr-text-at-halign|center|gr-text-at-valign|center|gr-auto-crop|false|<graphics||<line|<point|-1.0|1.0>|<point|-1.0|0.0>|<point|3.0|0.0>|<point|3.0|1.0>|<point|-1.0|1.0>>|<with|text-at-valign|center|text-at-halign|center|<math-at|x<rsub|0>|<point|-2|0.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|x<rsub|1>|<point|-2|-1>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|\<delta\>|<point|-0.5|0.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|p|<point|1.5|0.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|p|<point|4.5|-1>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|2<rsup|-2*p>|<point|6.0|1.75>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|2<rsup|-p>|<point|3.0|1.75>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|1|<point|0.0|1.75>>>|<with|dash-style|11100|<line|<point|0.0|1.49690765974335>|<point|0.0|-3.5>>>|<with|dash-style|11100|<line|<point|3.0|1.46742293954227>|<point|3.0|-3.5>>>|<with|dash-style|11100|<line|<point|6.0|1.46173435639635>|<point|6.0|-3.5>>>|<with|dash-style|11100|<spline|<point|9|1.5>|<point|9.0|-3.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|p|<point|7.5|-2.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|x<rsub|2>|<point|-2|-2.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|2<rsup|-3*p>|<point|9|1.75>>>|<line|<point|3.0|-0.5>|<point|3.0|-1.5>|<point|6.0|-1.5>|<point|6.0|-1.0>|<point|6.0|-0.5>|<point|3.0|-0.5>>|<line|<point|6.0|-2.0>|<point|6.0|-3.0>|<point|9.0|-3.0>|<point|9.25|-2.75>|<point|9.0|-2.5>|<point|9.25|-2.25>|<point|9.0|-2.0>|<point|6.0|-2.0>>>>>|<hidden|<with|gr-mode|<tuple|edit|line>|gr-frame|<tuple|scale|1.00002cm|<tuple|0.27gw|0.619996gh>>|gr-geometry|<tuple|geometry|0.727451par|0.286908par|center>|gr-transformation|<tuple|<tuple|0.764842187284488|0.0|-0.64421768723769|0.0>|<tuple|0.0|1.0|0.0|0.0>|<tuple|0.64421768723769|0.0|0.764842187284488|0.0>|<tuple|0.0|0.0|0.0|1.0>>|gr-grid|<tuple|empty>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|4|none>>|gr-edit-grid|<tuple|empty>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-grid-aspect|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|4|#e0e0ff>>|gr-grid-aspect-props|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|4|#e0e0ff>>|gr-text-at-halign|center|gr-text-at-valign|center|gr-auto-crop|false|gr-arrow-end|\<gtr\>|<graphics||<line|<point|-1.0|1.0>|<point|-1.0|0.0>|<point|3.0|0.0>|<point|3.0|1.0>|<point|-1.0|1.0>>|<with|text-at-valign|center|text-at-halign|center|<math-at|x<rsub|0>|<point|-2|0.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|x<rsub|1>|<point|-2|-1>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|\<delta\>|<point|-0.5|0.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|p|<point|1.5|0.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|p|<point|4.5|-1>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|2<rsup|-2*p>|<point|6.0|1.75>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|2<rsup|-p>|<point|3.0|1.75>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|1|<point|0.0|1.75>>>|<with|dash-style|11100|<line|<point|0.0|1.49690765974335>|<point|0.0|-3.5>>>|<with|dash-style|11100|<line|<point|3.0|1.46742293954227>|<point|3.0|-3.5>>>|<with|dash-style|11100|<line|<point|6.0|1.46173435639635>|<point|6.0|-3.5>>>|<with|dash-style|11100|<spline|<point|9|1.5>|<point|9.0|-3.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|p|<point|7.5|-2.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|x<rsub|2>|<point|-2|-2.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|2<rsup|-3*p>|<point|9|1.75>>>|<line|<point|3.125|-0.5>|<point|3.125|-1.5>|<point|6.0|-1.5>|<point|6.0|-1.0>|<point|6.0|-0.5>|<point|3.25|-0.5>>|<line|<point|2.875|-1.5>|<point|2.875|-0.5>|<point|2.0|-0.5>|<point|2.0|-1.5>|<point|2.875|-1.5>>|<line|<point|6.125|-2.0>|<point|6.125|-3.0>|<point|9.0|-3.0>|<point|9.25|-2.75>|<point|9.0|-2.5>|<point|9.25|-2.25>|<point|9.0|-2.0>|<point|6.125|-2.0>>|<line|<point|5.875|-2>|<point|5.875|-3.0>|<point|5.0|-3.0>|<point|5.0|-2.0>|<point|5.875|-2.0>>|<with|arrow-end|\<gtr\>|<line|<point|2.5|-0.5>|<point|2.5|0.0>>>|<with|arrow-end|\<gtr\>|<line|<point|5.5|-2>|<point|5.5|-1.5>>>|<with|color|blue|text-at-valign|center|text-at-halign|center|<math-at|<with|color|blue|+>|<point|5.5|-2.5>>>|<with|color|blue|text-at-valign|center|text-at-halign|center|<math-at|<with|color|blue|+>|<point|2.5|-1.0>>>>>>><htab|5mm>
  </hidden>|<\hidden>
    <tit|Normalization <em|via> splitting>

    <unroll|<\shown>
      Input: IEEE number <math|x\<in\>\<bbb-F\>> and exponent
      <math|e\<in\><around*|{|E<rsub|min>,\<ldots\>,E<rsub|max>-\<mu\>|}>>
      with <math|<around*|\||x|\|>\<less\>2<rsup|e+\<mu\>-2>>.

      Output: IEEE number <math|<wide|x|~>\<in\>\<bbb-F\>> with
      <math|<wide|x|~>\<in\>\<bbb-Z\>*2<rsup|e>> and
      <math|<around*|\||<wide|x|~>-x|\|>\<less\>2<rsup|e>>.

      <\named-algorithm|Split<rsub|<math|e>>(<math|x>)>
        <math|a\<assign\><math-ordinary|\<circle\>><around*|(|x+<frac*|3|2>\<cdot\>2<rsup|e+\<mu\>>|)>>

        <strong|return> <math|<math-ordinary|\<circle\>>><math|<around*|(|a-<frac*|3|2>\<cdot\>2<rsup|e+\<mu\>>|)>>
      </named-algorithm>

      \;
    </shown>|<\hidden*>
      <switch|<\shown>
        Normalization for <math|k=2>:

        <\named-algorithm|Normalize(<math|x>)>
          <math|c\<assign\>Split<rsub|-p><around*|(|x<rsub|1>|)>>

          <strong|return> <math|<around*|\<llbracket\>|<math-ordinary|\<circle\>><around*|(|x<rsub|0>+c|)>,<math-ordinary|\<circle\>><around*|(|x<rsub|1>-c|)>|\<rrbracket\>>>
        </named-algorithm>
      </shown>|<\hidden>
        Normalization for general <math|k>:

        <\named-algorithm|Normalize(<math|x>)>
          <math|r<rsub|k-1>\<assign\>x<rsub|k-1>>

          <strong|for> <math|i> <strong|from> <math|k-1> <strong|down to>
          <math|1> <strong|do>

          <\indent>
            <math|c<rsub|i>\<assign\>Split<rsub|-i*p><around*|(|r<rsub|i>|)>>

            <math|<wide|x|~><rsub|i>\<assign\><math-ordinary|\<circle\>><around*|(|r<rsub|i>-c<rsub|i>|)>>

            <math|r<rsub|i-1>\<assign\><math-ordinary|\<circle\>><around*|(|x<rsub|i-1>+c<rsub|i>|)>>
          </indent>

          <math|<wide|x|~><rsub|0>\<assign\>r<rsub|0>>

          <strong|return> <math|<around*|\<llbracket\>|<wide|x|~><rsub|0>,\<ldots\>,<wide|x|~><rsub|k-1>|\<rrbracket\>>>
        </named-algorithm>
      </hidden>>
    </hidden*>>

    \;
  </hidden>|<\hidden>
    <tit|Unnormalized arithmetic operations <math|k=2>>

    \;

    <unroll|<\shown>
      <\named-algorithm|Add<math|<around*|(|x,y|)>>>
        <strong|return> <math|<around*|\<llbracket\>|<math-ordinary|\<circle\>><around*|(|x<rsub|0>+y<rsub|0>|)>,<math-ordinary|\<circle\>><around*|(|x<rsub|1>+y<rsub|1>|)>|\<rrbracket\>>>
      </named-algorithm>
    </shown>|<\hidden*>
      <\named-algorithm|LongMul<rsub|<math|e>><math|<around*|(|x,y|)>>>
        <math|a\<assign\><math-ordinary|\<circle\>><around*|(|x*y+<frac*|3|2>\<cdot\>2<rsup|e+\<mu\>>|)>>

        <math|h\<assign\><math-ordinary|\<circle\>><around*|(|a-<frac*|3|2>\<cdot\>2<rsup|e+\<mu\>>|)>>

        <math|l\<assign\><math-ordinary|\<circle\>><around*|(|x*y-h|)>>

        <strong|return> <math|<around*|(|h,l|)>>
      </named-algorithm>
    </hidden*>|<\hidden*>
      <\named-algorithm|Multiply<math|<around*|(|x,y|)>>>
        <math|<around*|(|h,l|)>\<assign\>LongMul<rsub|-p><around*|(|x<rsub|0>,y<rsub|0>|)>>

        <math|l\<assign\><math-ordinary|\<circle\>><around*|(|x<rsub|0>*y<rsub|1>+l|)>>

        <math|l\<assign\><math-ordinary|\<circle\>><around*|(|x<rsub|1>*y<rsub|0>+l|)>>

        <strong|return> <math|<around*|\<llbracket\>|h,l|\<rrbracket\>>>
      </named-algorithm>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Unnormalized arithemetic operations, general <math|k> >

    \;

    <\named-algorithm|Add<math|<around*|(|x,y|)>>>
      <strong|return> <math|<around*|\<llbracket\>|<math-ordinary|\<circle\>><around*|(|x<rsub|0>+y<rsub|0>|)>,\<ldots\>,<math-ordinary|\<circle\>><around*|(|x<rsub|k-1>+y<rsub|k-1>|)>|\<rrbracket\>>>
    </named-algorithm>

    \;

    <\named-algorithm|Multiply(<math|x,y>)>
      <math|<around*|(|r<rsub|0>,r<rsub|1>|)>\<assign\>LongMul<rsub|-p><around*|(|x<rsub|0>,y<rsub|0>|)>>

      <strong|for> <math|i> <strong|from> <math|1> <strong|to> <math|k-2>
      <strong|do>

      <\indent>
        <math|<around*|(|h,r<rsub|i+1>|)>\<assign\>LongMul<rsub|-<around*|(|i+1|)>*p><around*|(|x<rsub|0>,y<rsub|i>|)>>

        <math|r<rsub|i>\<assign\><math-ordinary|\<circle\>><around*|(|r<rsub|i>+h|)>>

        <strong|for> <math|j> <strong|from> <math|1> <strong|to> <math|i>
        <strong|do>

        <\indent>
          <math|<around*|(|h,l|)>\<assign\>LongMul<rsub|-<around*|(|i+1|)>*p><around*|(|x<rsub|j>,y<rsub|i-j>|)>>

          <math|r<rsub|i>\<assign\><math-ordinary|\<circle\>><around*|(|r<rsub|i>+h|)>>

          <math|r<rsub|i+1>\<assign\><math-ordinary|\<circle\>><around*|(|r<rsub|i+1>+l|)>>
        </indent>
      </indent>

      <strong|for> <math|i> <strong|from> <math|0> <strong|to> <math|k-1>
      <strong|do>

      <\indent>
        <math|r<rsub|k-1>\<assign\><math-ordinary|\<circle\>><around*|(|x<rsub|i>*y<rsub|k-1-i>+r<rsub|k-1>|)>>
      </indent>

      <strong|return> <math|<around*|\<llbracket\>|r<rsub|0>,\<ldots\>,r<rsub|k-1>|\<rrbracket\>>>
    </named-algorithm>
  </hidden>|<\hidden>
    <tit|Unnormalized multiplication>

    <with|gr-mode|<tuple|edit|line>|gr-frame|<tuple|scale|1cm|<tuple|0.5gw|0.599997gh>>|gr-geometry|<tuple|geometry|1par|0.678242par|center>|gr-grid|<tuple|empty>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|4|none>>|gr-edit-grid|<tuple|empty>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-grid-aspect|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|4|#e0e0ff>>|gr-grid-aspect-props|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|4|#e0e0ff>>|gr-text-at-halign|center|gr-text-at-valign|center|gr-color|blue|gr-arrow-end|\<gtr\>|<graphics||<cline|<point|-4|6>|<point|-4.0|5.0>|<point|0.0|5.0>|<point|0.0|6.0>>|<cline|<point|-2|4.5>|<point|-2.0|3.5>|<point|2.0|3.5>|<point|2.0|4.5>>|<with|color|blue|dash-style|10|<line|<point|0|2>|<point|0.0|-8.0>>>|<cline|<point|-2|3>|<point|-2.0|2.0>|<point|2.0|2.0>|<point|2.0|3.0>>|<with|dash-style|10|<line|<point|-2|6>|<point|-2.0|5.0>>>|<with|dash-style|10|<line|<point|0|4.5>|<point|0.0|3.5>>>|<with|dash-style|10|<line|<point|0|3>|<point|0.0|2.0>>>|<with|dash-style|10|<line|<point|2|1.5>|<point|2.25|1.25>|<point|2.0|1.0>|<point|2.25|0.75>|<point|2.0|0.5>>>|<with|dash-style|10|<line|<point|2|0>|<point|2.25|-0.25>|<point|2.0|-0.5>|<point|2.25|-0.75>|<point|2.0|-1.0>>>|<with|dash-style|10|<line|<point|2|-1.5>|<point|2.25|-1.75>|<point|2.0|-2.0>|<point|2.25|-2.25>|<point|2.0|-2.5>>>|<line|<point|2|1.5>|<point|0.0|1.5>|<point|0.0|0.5>|<point|2.0|0.5>>|<line|<point|2|0>|<point|0.0|0.0>|<point|0.0|-1.0>|<point|2.0|-1.0>>|<cline|<point|-4|-4>|<point|-4.0|-5.0>|<point|-2.0|-5.0>|<point|-2.0|-4.0>>|<cline|<point|-2.25|-5.5>|<point|-2.25|-6.5>|<point|0.0|-6.5>|<point|0.0|-5.5>>|<with|color|blue|dash-style|10|<line|<point|-2|5>|<point|-2.0|-6.5>>>|<cline|<point|-0.5|-7>|<point|-0.5|-8.0>|<point|2.0|-8.0>|<point|2.25|-7.75>|<point|2.0|-7.5>|<point|2.25|-7.25>|<point|2.0|-7.0>>|<with|text-at-valign|center|text-at-halign|center|<math-at|x<rsub|0>*y<rsub|0>|<point|-2|5.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|x<rsub|0>*y<rsub|1>|<point|0|4>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|x<rsub|1>*y<rsub|0>|<point|0|2.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|x<rsub|0>*y<rsub|2>|<point|1|1>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|x<rsub|1>*y<rsub|1>|<point|1|-0.5>>>|<with|text-at-valign|center|text-at-halign|center|<math-at|x<rsub|2>*y<rsub|0>|<point|1|-2>>>|<with|color|blue|dash-style|10|<line|<point|-4|5>|<point|-4.0|-4.0>>>|<with|color|blue|dash-style|10|<line|<point|0|3.5>|<point|0.0|2.89137121312343>>>|<with|color|blue|dash-style|10|<line|<point|0|5>|<point|0.0|4.5>>>|<with|color|blue|dash-style|10|<line|<point|2|3.5>|<point|2.0|3.0>>>|<with|color|blue|dash-style|10|<line|<point|2|2>|<point|2.0|1.5>>>|<with|color|blue|dash-style|10|<line|<point|2|0.5>|<point|2.0|0.0>>>|<with|color|blue|dash-style|10|<line|<point|2|-1>|<point|2.0|-1.5>>>|<with|color|blue|dash-style|10|<line|<point|2|-2.5>|<point|2.0|-7.0>>>|<line|<point|2|-1.5>|<point|0.0|-1.5>|<point|0.0|-2.5>|<point|2.0|-2.5>>|<with|color|blue|text-at-valign|center|text-at-halign|center|<math-at|<with|color|blue|+>|<point|-3|-3.5>>>|<with|color|blue|text-at-valign|center|text-at-halign|center|<math-at|<with|color|blue|+>|<point|-1|-5>>>|<with|color|blue|text-at-valign|center|text-at-halign|center|<math-at|<with|color|blue|+>|<point|1|-6.5>>>|<with|color|blue|arrow-end|\<gtr\>|<line|<point|-3|-1>|<point|-3.0|-2.0>>>|<with|color|blue|arrow-end|\<gtr\>|<line|<point|-1|-2.5>|<point|-1.0|-3.5>>>|<with|color|blue|arrow-end|\<gtr\>|<line|<point|1|-4>|<point|1.0|-5.0>>>>>
  </hidden>|<\hidden>
    <tit|FFTs>

    <\named-algorithm|ComplexMultiply(<math|u,v>)>
      <math|a\<assign\>Multiply<around*|(|\<Re\>u,\<Re\>v|)>>

      <math|b\<assign\>Multiply<around*|(|\<Im\>u,\<Im\>v|)>>

      <math|c\<assign\>Multiply<around*|(|\<Re\>u,\<Im\>v|)>>

      <math|d\<assign\>Multiply<around*|(|\<Im\>u,\<Re\>v|)>>

      <strong|return> <math|Subtract<around*|(|a,b|)>+Add<around*|(|c,d|)>*\<mathi\>>
    </named-algorithm>

    \;

    <\eqnarray*>
      <tformat|<table|<row|<cell|<wide|u|~>>|<cell|=>|<cell|u+\<omega\>*v>>|<row|<cell|<wide|v|~>>|<cell|=>|<cell|u-\<omega\>*v>>>>
    </eqnarray*>

    <\named-algorithm|DirectButterfly<math|<around*|(|u,v,\<omega\>|)>>>
      <math|z\<assign\>ComplexMultiply<around*|(|\<omega\>,v|)>>

      <math|u<rprime|'>\<assign\>ComplexAdd<around*|(|u,z|)>>

      <math|v<rprime|'>\<assign\>ComplexSubtract<around*|(|u,z|)>>

      <math|<wide|u|~>\<assign\>ComplexNormalize<around*|(|u<rprime|'>|)>>

      <math|<wide|v|~>\<assign\>ComplexNormalize<around*|(|v<rprime|'>|)>>

      <strong|return> <math|<around*|(|<wide|u|~>,<wide|v|~>|)>>
    </named-algorithm>
  </hidden>|<\hidden>
    <tit|Benchmarks>

    \;

    <big-table|<tabular|<tformat|<table|<row|<cell|<flat-size|<block*|<tformat|<cwith|2|-1|2|-1|cell-halign|C.>|<cwith|7|9|2|10|cell-halign|C.>|<cwith|1|1|1|-1|cell-background|<pattern|/Users/vdhoeven/texmacs/src/TeXmacs/misc/patterns/ice-medium-blue.png||>>|<cwith|7|9|1|-1|cell-background|<pattern|/Users/vdhoeven/texmacs/src/TeXmacs/misc/patterns/paper-manila-medium.png||>>|<cwith|10|10|1|-1|cell-background|<pattern|/Users/vdhoeven/texmacs/src/TeXmacs/misc/patterns/pine.png||>>|<cwith|11|14|2|10|cell-halign|C.>|<cwith|12|12|2|10|cell-halign|C.>|<cwith|11|11|2|10|cell-halign|C.>|<table|<row|<cell|<math|\<nu\>>>|<cell|8>|<cell|9>|<cell|10>|<cell|11>|<cell|12>|<cell|13>|<cell|14>|<cell|15>|<cell|16>>|<row|<cell|<cpp|double>>|<cell|0.54>|<cell|1.1>|<cell|2.5>|<cell|6.8>|<cell|16>|<cell|37>|<cell|85>|<cell|220>|<cell|450>>|<row|<cell|<cpp|long
    double>>|<cell|9.5>|<cell|21>|<cell|48>|<cell|110>|<cell|230>|<cell|500>|<cell|1100>|<cell|2300>|<cell|5000>>|<row|<cell|<with|color|dark
    magenta|<cpp|__float128>>>|<cell|94>|<cell|220>|<cell|490>|<cell|1100>|<cell|2400>|<cell|5300>|<cell|11000>|<cell|25000>|<cell|53000>>|<row|<cell|<cpp|quadruple>>|<cell|5.0>|<cell|11>|<cell|25>|<cell|55>|<cell|120>|<cell|260>|<cell|570>|<cell|1200>|<cell|2600>>|<row|<cell|<cpp|fixed_quadruple>>|<cell|2.8>|<cell|6.4>|<cell|15>|<cell|33>|<cell|71>|<cell|160>|<cell|380>|<cell|820>|<cell|1700>>|<row|<cell|FFTW3
    <cpp|double>>|<cell|0.43>|<cell|0.94>|<cell|2.3>|<cell|5.4>|<cell|15>|<cell|34>|<cell|85>|<cell|190>|<cell|400>>|<row|<cell|FFTW3
    <cpp|long double>>|<cell|6.1>|<cell|14>|<cell|31>|<cell|70>|<cell|153>|<cell|332>|<cell|720>|<cell|1600>|<cell|3400>>|<row|<cell|FFTW3
    <with|color|dark magenta|<cpp|__float128>>>|<cell|89>|<cell|205>|<cell|463>|<cell|1000>|<cell|2300>|<cell|5100>|<cell|11000>|<cell|24000>|<cell|51000>>|<row|<cell|MPFR
    (113 bits)>|<cell|270>|<cell|610>|<cell|1400>|<cell|3100>|<cell|6800>|<cell|15000>|<cell|33000>|<cell|81000>|<cell|230000>>|<row|<cell|<cpp|double>>|<cell|0.54>|<cell|1.1>|<cell|2.5>|<cell|6.8>|<cell|16>|<cell|37>|<cell|85>|<cell|220>|<cell|450>>|<row|<cell|<cpp|fixed_quadruple>>|<cell|2.8>|<cell|6.4>|<cell|15>|<cell|33>|<cell|71>|<cell|160>|<cell|380>|<cell|820>|<cell|1700>>|<row|<cell|<cpp|fixed_hexuple>>|<cell|7.6>|<cell|17>|<cell|38>|<cell|84>|<cell|180>|<cell|400>|<cell|870>|<cell|1800>|<cell|3900>>|<row|<cell|<cpp|fixed_octuple>>|<cell|18>|<cell|42>|<cell|93>|<cell|200>|<cell|450>|<cell|980>|<cell|2100>|<cell|4500>|<cell|9600>>>>>>>>>>>|<label|tab:mmx>FFT
    timings for size <math|n=2<rsup|\<nu\>>>, in micro-seconds.>
  </hidden>|<\hidden>
    <tit|Hardware support?>

    \;

    <\itemize>
      <unroll|<\shown>
        <item>Classical double-double arithmetic: hardware
        <anim-repeat|<anim-compose|<anim-constant|FusedAddAdd
        instruction.|2sec>|<anim-constant|FusedAddSubtract
        instruction.|2sec>|<anim-constant|FusedSubtractAdd
        instruction.|2sec>|<anim-constant|FusedSubtractSubtract
        instruction.|2sec>>>
      </shown>|<\hidden*>
        <item>For our approach, faithful rounding more important than correct
        rounding.
      </hidden*>|<\hidden*>
        <item>Instructions for faster splitting-normalization would be nice.
        <abbr|E.g.>:

        <\itemize-minus>
          <item>Built-in Split instruction (RoundScale?).

          <item>Instruction for <math|<around*|(|a,b|)>\<mapsto\><around*|(|a+b,a-b|)>>.
        </itemize-minus>
      </hidden*>|<\hidden*>
        <item>Better support for long multiplication.
      </hidden*>|<\hidden*>
        <item>What about integer instructions for SIMD large integer
        multiplication?
      </hidden*>>
    </itemize>
  </hidden>>
</body>

<\initial>
  <\collection>
    <associate|info-flag|minimal>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|?>>
    <associate|chirp-formula|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|it-log|<tuple|?|4>>
    <associate|log-slow-cond|<tuple|?|19>>
    <associate|mersenne-conj|<tuple|1|21>>
    <associate|split-prop|<tuple|1|?>>
    <associate|tab:mmx|<tuple|1|?>>
    <associate|wrap-fig|<tuple|?|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|table>
      <tuple|normal|FFT timings for size <with|color|<quote|#503050>|font-family|<quote|ss>|<with|mode|<quote|math>|n=2<rsup|\<nu\>>>>,
      in micro-seconds.|<pageref|auto-1>>
    </associate>
  </collection>
</auxiliary>